diff --git a/rsvg-css.c b/rsvg-css.c
index e988ce5..5b359a2 100644
--- a/rsvg-css.c
+++ b/rsvg-css.c
@@ -988,321 +838,64 @@ rsvg_css_parse_overflow (const char *str, gboolean * inherit)
     return 0;
 }
 
-/***********************************************************************/
-/***********************************************************************/
-
-/* 
-   Code largely based on xmltok_impl.c from Expat
-
-   Copyright (c) 1998, 1999, 2000 Thai Open Source Software Center Ltd
-   and Clark Cooper
-   Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006 Expat maintainers.
-   
-   Permission is hereby granted, free of charge, to any person obtaining
-   a copy of this software and associated documentation files (the
-   "Software"), to deal in the Software without restriction, including
-   without limitation the rights to use, copy, modify, merge, publish,
-   distribute, sublicense, and/or sell copies of the Software, and to
-   permit persons to whom the Software is furnished to do so, subject to
-   the following conditions:
-   
-   The above copyright notice and this permission notice shall be included
-   in all copies or substantial portions of the Software.
-   
-   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
-   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
-   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
-   IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
-   CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
-   TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
-   SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
-*/
-
-#include <stdio.h>
-#include <stdlib.h>
-#include <string.h>
-
-typedef struct {
-    const char *name;
-    const char *valuePtr;
-    const char *valueEnd;
-    char normalized;
-} ATTRIBUTE;
-
-#define PTRCALL
-#define PTRFASTCALL
-#define PREFIX(x) x
-typedef void ENCODING;
-
-#define BYTE_TO_ASCII(enc, p) (*(p))
-
-/* minimum bytes per character */
-#define MINBPC(enc) 1
-
-#define BYTE_TYPE(enc, p) utf8_byte_type_table[(int)(*(p))]
-
-#define ASCII_SPACE 0x20
-
-enum {
-    BT_NONXML,
-    BT_MALFORM,
-    BT_LT,
-    BT_AMP,
-    BT_RSQB,
-    BT_LEAD2,
-    BT_LEAD3,
-    BT_LEAD4,
-    BT_TRAIL,
-    BT_CR,
-    BT_LF,
-    BT_GT,
-    BT_QUOT,
-    BT_APOS,
-    BT_EQUALS,
-    BT_QUEST,
-    BT_EXCL,
-    BT_SOL,
-    BT_SEMI,
-    BT_NUM,
-    BT_LSQB,
-    BT_S,
-    BT_NMSTRT,
-    BT_COLON,
-    BT_HEX,
-    BT_DIGIT,
-    BT_NAME,
-    BT_MINUS,
-    BT_OTHER,                   /* known not to be a name or name start character */
-    BT_NONASCII,                /* might be a name or name start character */
-    BT_PERCNT,
-    BT_LPAR,
-    BT_RPAR,
-    BT_AST,
-    BT_PLUS,
-    BT_COMMA,
-    BT_VERBAR
-};
-
-static const char utf8_byte_type_table[] = {
-    /* 0x00 */ BT_NONXML, BT_NONXML, BT_NONXML, BT_NONXML,
-    /* 0x04 */ BT_NONXML, BT_NONXML, BT_NONXML, BT_NONXML,
-    /* 0x08 */ BT_NONXML, BT_S, BT_LF, BT_NONXML,
-    /* 0x0C */ BT_NONXML, BT_CR, BT_NONXML, BT_NONXML,
-    /* 0x10 */ BT_NONXML, BT_NONXML, BT_NONXML, BT_NONXML,
-    /* 0x14 */ BT_NONXML, BT_NONXML, BT_NONXML, BT_NONXML,
-    /* 0x18 */ BT_NONXML, BT_NONXML, BT_NONXML, BT_NONXML,
-    /* 0x1C */ BT_NONXML, BT_NONXML, BT_NONXML, BT_NONXML,
-    /* 0x20 */ BT_S, BT_EXCL, BT_QUOT, BT_NUM,
-    /* 0x24 */ BT_OTHER, BT_PERCNT, BT_AMP, BT_APOS,
-    /* 0x28 */ BT_LPAR, BT_RPAR, BT_AST, BT_PLUS,
-    /* 0x2C */ BT_COMMA, BT_MINUS, BT_NAME, BT_SOL,
-    /* 0x30 */ BT_DIGIT, BT_DIGIT, BT_DIGIT, BT_DIGIT,
-    /* 0x34 */ BT_DIGIT, BT_DIGIT, BT_DIGIT, BT_DIGIT,
-    /* 0x38 */ BT_DIGIT, BT_DIGIT, BT_COLON, BT_SEMI,
-    /* 0x3C */ BT_LT, BT_EQUALS, BT_GT, BT_QUEST,
-    /* 0x40 */ BT_OTHER, BT_HEX, BT_HEX, BT_HEX,
-    /* 0x44 */ BT_HEX, BT_HEX, BT_HEX, BT_NMSTRT,
-    /* 0x48 */ BT_NMSTRT, BT_NMSTRT, BT_NMSTRT, BT_NMSTRT,
-    /* 0x4C */ BT_NMSTRT, BT_NMSTRT, BT_NMSTRT, BT_NMSTRT,
-    /* 0x50 */ BT_NMSTRT, BT_NMSTRT, BT_NMSTRT, BT_NMSTRT,
-    /* 0x54 */ BT_NMSTRT, BT_NMSTRT, BT_NMSTRT, BT_NMSTRT,
-    /* 0x58 */ BT_NMSTRT, BT_NMSTRT, BT_NMSTRT, BT_LSQB,
-    /* 0x5C */ BT_OTHER, BT_RSQB, BT_OTHER, BT_NMSTRT,
-    /* 0x60 */ BT_OTHER, BT_HEX, BT_HEX, BT_HEX,
-    /* 0x64 */ BT_HEX, BT_HEX, BT_HEX, BT_NMSTRT,
-    /* 0x68 */ BT_NMSTRT, BT_NMSTRT, BT_NMSTRT, BT_NMSTRT,
-    /* 0x6C */ BT_NMSTRT, BT_NMSTRT, BT_NMSTRT, BT_NMSTRT,
-    /* 0x70 */ BT_NMSTRT, BT_NMSTRT, BT_NMSTRT, BT_NMSTRT,
-    /* 0x74 */ BT_NMSTRT, BT_NMSTRT, BT_NMSTRT, BT_NMSTRT,
-    /* 0x78 */ BT_NMSTRT, BT_NMSTRT, BT_NMSTRT, BT_OTHER,
-    /* 0x7C */ BT_VERBAR, BT_OTHER, BT_OTHER, BT_OTHER,
-    /* 0x80 */ BT_TRAIL, BT_TRAIL, BT_TRAIL, BT_TRAIL,
-    /* 0x84 */ BT_TRAIL, BT_TRAIL, BT_TRAIL, BT_TRAIL,
-    /* 0x88 */ BT_TRAIL, BT_TRAIL, BT_TRAIL, BT_TRAIL,
-    /* 0x8C */ BT_TRAIL, BT_TRAIL, BT_TRAIL, BT_TRAIL,
-    /* 0x90 */ BT_TRAIL, BT_TRAIL, BT_TRAIL, BT_TRAIL,
-    /* 0x94 */ BT_TRAIL, BT_TRAIL, BT_TRAIL, BT_TRAIL,
-    /* 0x98 */ BT_TRAIL, BT_TRAIL, BT_TRAIL, BT_TRAIL,
-    /* 0x9C */ BT_TRAIL, BT_TRAIL, BT_TRAIL, BT_TRAIL,
-    /* 0xA0 */ BT_TRAIL, BT_TRAIL, BT_TRAIL, BT_TRAIL,
-    /* 0xA4 */ BT_TRAIL, BT_TRAIL, BT_TRAIL, BT_TRAIL,
-    /* 0xA8 */ BT_TRAIL, BT_TRAIL, BT_TRAIL, BT_TRAIL,
-    /* 0xAC */ BT_TRAIL, BT_TRAIL, BT_TRAIL, BT_TRAIL,
-    /* 0xB0 */ BT_TRAIL, BT_TRAIL, BT_TRAIL, BT_TRAIL,
-    /* 0xB4 */ BT_TRAIL, BT_TRAIL, BT_TRAIL, BT_TRAIL,
-    /* 0xB8 */ BT_TRAIL, BT_TRAIL, BT_TRAIL, BT_TRAIL,
-    /* 0xBC */ BT_TRAIL, BT_TRAIL, BT_TRAIL, BT_TRAIL,
-    /* 0xC0 */ BT_LEAD2, BT_LEAD2, BT_LEAD2, BT_LEAD2,
-    /* 0xC4 */ BT_LEAD2, BT_LEAD2, BT_LEAD2, BT_LEAD2,
-    /* 0xC8 */ BT_LEAD2, BT_LEAD2, BT_LEAD2, BT_LEAD2,
-    /* 0xCC */ BT_LEAD2, BT_LEAD2, BT_LEAD2, BT_LEAD2,
-    /* 0xD0 */ BT_LEAD2, BT_LEAD2, BT_LEAD2, BT_LEAD2,
-    /* 0xD4 */ BT_LEAD2, BT_LEAD2, BT_LEAD2, BT_LEAD2,
-    /* 0xD8 */ BT_LEAD2, BT_LEAD2, BT_LEAD2, BT_LEAD2,
-    /* 0xDC */ BT_LEAD2, BT_LEAD2, BT_LEAD2, BT_LEAD2,
-    /* 0xE0 */ BT_LEAD3, BT_LEAD3, BT_LEAD3, BT_LEAD3,
-    /* 0xE4 */ BT_LEAD3, BT_LEAD3, BT_LEAD3, BT_LEAD3,
-    /* 0xE8 */ BT_LEAD3, BT_LEAD3, BT_LEAD3, BT_LEAD3,
-    /* 0xEC */ BT_LEAD3, BT_LEAD3, BT_LEAD3, BT_LEAD3,
-    /* 0xF0 */ BT_LEAD4, BT_LEAD4, BT_LEAD4, BT_LEAD4,
-    /* 0xF4 */ BT_LEAD4, BT_NONXML, BT_NONXML, BT_NONXML,
-    /* 0xF8 */ BT_NONXML, BT_NONXML, BT_NONXML, BT_NONXML,
-    /* 0xFC */ BT_NONXML, BT_NONXML, BT_MALFORM, BT_MALFORM
-};
-
-/* This must only be called for a well-formed start-tag or empty
-   element tag.  Returns the number of attributes.  Pointers to the
-   first attsMax attributes are stored in atts.
-*/
-
-static int PTRCALL
-PREFIX (getAtts) (const ENCODING * enc, const char *ptr, int attsMax, ATTRIBUTE * atts) {
-    enum { other, inName, inValue } state = inName;
-    int nAtts = 0;
-    int open = 0;               /* defined when state == inValue;
-                                   initialization just to shut up compilers */
-
-    for (ptr += MINBPC (enc);; ptr += MINBPC (enc)) {
-        switch (BYTE_TYPE (enc, ptr)) {
-
-#define START_NAME \
-      if (state == other) { \
-        if (nAtts < attsMax) { \
-          atts[nAtts].name = ptr; \
-          atts[nAtts].normalized = 1; \
-        } \
-        state = inName; \
-      }
-
-#define LEAD_CASE(n) \
-    case BT_LEAD ## n: START_NAME ptr += (n - MINBPC(enc)); break;
-            LEAD_CASE (2) LEAD_CASE (3) LEAD_CASE (4)
-#undef LEAD_CASE
-        case BT_NONASCII:
-        case BT_NMSTRT:
-        case BT_HEX:
-            START_NAME break;
-#undef START_NAME
-        case BT_QUOT:
-            if (state != inValue) {
-                if (nAtts < attsMax)
-                    atts[nAtts].valuePtr = ptr + MINBPC (enc);
-                state = inValue;
-                open = BT_QUOT;
-            } else if (open == BT_QUOT) {
-                state = other;
-                if (nAtts < attsMax)
-                    atts[nAtts].valueEnd = ptr;
-                nAtts++;
-            }
-            break;
-        case BT_APOS:
-            if (state != inValue) {
-                if (nAtts < attsMax)
-                    atts[nAtts].valuePtr = ptr + MINBPC (enc);
-                state = inValue;
-                open = BT_APOS;
-            } else if (open == BT_APOS) {
-                state = other;
-                if (nAtts < attsMax)
-                    atts[nAtts].valueEnd = ptr;
-                nAtts++;
-            }
-            break;
-        case BT_AMP:
-            if (nAtts < attsMax)
-                atts[nAtts].normalized = 0;
-            break;
-        case BT_S:
-            if (state == inName)
-                state = other;
-            else if (state == inValue
-                     && nAtts < attsMax
-                     && atts[nAtts].normalized
-                     && (ptr == atts[nAtts].valuePtr
-                         || BYTE_TO_ASCII (enc, ptr) != ASCII_SPACE
-                         || BYTE_TO_ASCII (enc, ptr + MINBPC (enc)) == ASCII_SPACE
-                         || BYTE_TYPE (enc, ptr + MINBPC (enc)) == open))
-                atts[nAtts].normalized = 0;
-            break;
-        case BT_CR:
-        case BT_LF:
-            /* This case ensures that the first attribute name is counted
-               Apart from that we could just change state on the quote. */
-            if (state == inName)
-                state = other;
-            else if (state == inValue && nAtts < attsMax)
-                atts[nAtts].normalized = 0;
-            break;
-        case BT_GT:
-        case BT_SOL:
-            if (state != inValue)
-                return nAtts;
-            break;
-        default:
-            break;
-        }
-    }
-    /* not reached */
-}
-
-static int PTRFASTCALL PREFIX (nameLength) (const ENCODING * enc, const char *ptr) {
-    const char *start = ptr;
-    for (;;) {
-        switch (BYTE_TYPE (enc, ptr)) {
-#define LEAD_CASE(n) \
-    case BT_LEAD ## n: ptr += n; break;
-            LEAD_CASE (2) LEAD_CASE (3) LEAD_CASE (4)
-#undef LEAD_CASE
-        case BT_NONASCII:
-        case BT_NMSTRT:
-#ifdef XML_NS
-        case BT_COLON:
-#endif
-        case BT_HEX:
-        case BT_DIGIT:
-        case BT_NAME:
-        case BT_MINUS:
-            ptr += MINBPC (enc);
-            break;
-        default:
-            return (int) (ptr - start);
-        }
-    }
+static void
+rsvg_xml_noerror (void *data, xmlErrorPtr error)
+{
 }
 
+/* This is quite hacky and not entirely correct, but apparently 
+ * libxml2 has NO support for parsing pseudo attributes as defined 
+ * by the xml-styleheet spec.
+ */
 char **
 rsvg_css_parse_xml_attribute_string (const char *attribute_string)
 {
-    int i, nb_atts;
-    ATTRIBUTE *attributes;
-    int attrSize = 16;
-    ENCODING *enc = NULL;
-    char **atts;
-    char *_attribute_string;
-
-    _attribute_string = g_strdup_printf ("<tag %s />\n", attribute_string);
-    attributes = g_new (ATTRIBUTE, attrSize);
-
-    nb_atts = getAtts (enc, _attribute_string, attrSize, attributes);
-    if (nb_atts > attrSize) {
-        attrSize = nb_atts;
-        g_free (attributes);
-
-        attributes = g_new (ATTRIBUTE, attrSize);
-        nb_atts = getAtts (enc, _attribute_string, attrSize, attributes);
+    xmlSAXHandler handler;
+    xmlParserCtxtPtr parser;
+    xmlDocPtr doc;
+    xmlNodePtr node;
+    xmlAttrPtr attr;
+    char *tag;
+    GPtrArray *attributes;
+    char **retval = NULL;
+
+    tag = g_strdup_printf ("<rsvg-hack %s />\n", attribute_string);
+
+    memset (&handler, 0, sizeof (handler));
+    xmlSAX2InitDefaultSAXHandler (&handler, 0);
+    handler.serror = rsvg_xml_noerror;
+    parser = xmlCreatePushParserCtxt (&handler, NULL, tag, strlen (tag) + 1, NULL);
+    parser->options |= XML_PARSE_NONET;
+
+    if (xmlParseDocument (parser) != 0)
+        goto done;
+
+    if ((doc = parser->myDoc) == NULL ||
+        (node = doc->children) == NULL ||
+        strcmp ((const char *) node->name, "rsvg-hack") != 0 ||
+        node->next != NULL ||
+        node->properties == NULL)
+          goto done;
+
+    attributes = g_ptr_array_new ();
+    for (attr = node->properties; attr; attr = attr->next) {
+        xmlNodePtr content = attr->children;
+
+        g_ptr_array_add (attributes, g_strdup ((char *) attr->name));
+        if (content)
+          g_ptr_array_add (attributes, g_strdup ((char *) content->content));
+        else
+          g_ptr_array_add (attributes, g_strdup (""));
     }
 
-    atts = g_new0 (char *, ((2 * nb_atts) + 1));
-    for (i = 0; i < nb_atts; i++) {
-        atts[(2 * i)] = g_strdup (attributes[i].name);
-        atts[(2 * i)][nameLength (enc, attributes[i].name)] = '\0';
-        atts[(2 * i) + 1] = g_strdup (attributes[i].valuePtr);
-        atts[(2 * i) + 1][attributes[i].valueEnd - attributes[i].valuePtr] = '\0';
-    }
+    g_ptr_array_add (attributes, NULL);
+    retval = (char **) g_ptr_array_free (attributes, FALSE);
 
-    g_free (attributes);
-    g_free (_attribute_string);
+  done:
+    if (parser->myDoc)
+      xmlFreeDoc (parser->myDoc);
+    xmlFreeParserCtxt (parser);
+    g_free (tag);
 
-    return atts;
+    return retval;
 }
diff --git a/rsvg-css.h b/rsvg-css.h
index 6fa2561..6abeba9 100644
--- a/rsvg-css.h
+++ b/rsvg-css.h
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-css.h : CSS utility functions
 
@@ -26,8 +27,11 @@
 #define RSVG_CSS_H
 
 #include <glib.h>
+
+#ifdef RSVG_COMPILATION
 #include <pango/pango.h>
 #include "rsvg-private.h"
+#endif
 
 G_BEGIN_DECLS
 
@@ -43,31 +47,45 @@ G_BEGIN_DECLS
 #define RSVG_ASPECT_RATIO_XMAX_YMAX (1 << 8)
 #define RSVG_ASPECT_RATIO_SLICE (1 << 31)
 
-int	    rsvg_css_parse_aspect_ratio	    (const char *str);
-
-gboolean    rsvg_css_param_match	    (const char *str, const char *param_name);
-int	    rsvg_css_param_arg_offset	    (const char *str);
-
-guint32	    rsvg_css_parse_color	    (const char *str, gboolean * inherit);
-guint	    rsvg_css_parse_opacity	    (const char *str);
-double	    rsvg_css_parse_angle	    (const char *str);
-double	    rsvg_css_parse_frequency	    (const char *str);
-double	    rsvg_css_parse_time		    (const char *str);
+/* This one is semi-public for mis-use in rsvg-convert */
+guint32	    rsvg_css_parse_color        (const char *str, gboolean * inherit);
 
-PangoStyle	 rsvg_css_parse_font_style	(const char *str, gboolean * inherit);
-PangoVariant	 rsvg_css_parse_font_variant	(const char *str, gboolean * inherit);
-PangoWeight	 rsvg_css_parse_font_weight	(const char *str, gboolean * inherit);
-PangoStretch	 rsvg_css_parse_font_stretch	(const char *str, gboolean * inherit);
-const char	*rsvg_css_parse_font_family	(const char *str, gboolean * inherit);
+#ifdef RSVG_COMPILATION
 
-RsvgViewBox	  rsvg_css_parse_vbox			(const char *vbox);
-void		  rsvg_css_parse_number_optional_number	(const char *str, double *x, double *y);
-gchar		**rsvg_css_parse_list			(const char *in_str, guint * out_list_len);
-gdouble		 *rsvg_css_parse_number_list		(const char *in_str, guint * out_list_len);
-
-gboolean	  rsvg_css_parse_overflow		(const char *str, gboolean * inherit);
-
-char		**rsvg_css_parse_xml_attribute_string	(const char *attribute_string);
+G_GNUC_INTERNAL
+int	    rsvg_css_parse_aspect_ratio	    (const char *str);
+G_GNUC_INTERNAL
+guint       rsvg_css_parse_opacity	    (const char *str);
+G_GNUC_INTERNAL
+double      rsvg_css_parse_angle        (const char *str);
+G_GNUC_INTERNAL
+double      rsvg_css_parse_frequency    (const char *str);
+G_GNUC_INTERNAL
+double      rsvg_css_parse_time         (const char *str);
+G_GNUC_INTERNAL
+PangoStyle   rsvg_css_parse_font_style      (const char *str, gboolean * inherit);
+G_GNUC_INTERNAL
+PangoVariant rsvg_css_parse_font_variant    (const char *str, gboolean * inherit);
+G_GNUC_INTERNAL
+PangoWeight	 rsvg_css_parse_font_weight	    (const char *str, gboolean * inherit);
+G_GNUC_INTERNAL
+PangoStretch rsvg_css_parse_font_stretch    (const char *str, gboolean * inherit);
+G_GNUC_INTERNAL
+const char  *rsvg_css_parse_font_family	    (const char *str, gboolean * inherit);
+G_GNUC_INTERNAL
+RsvgViewBox	  rsvg_css_parse_vbox           (const char *vbox);
+G_GNUC_INTERNAL
+void          rsvg_css_parse_number_optional_number	(const char *str, double *x, double *y);
+G_GNUC_INTERNAL
+gchar       **rsvg_css_parse_list           (const char *in_str, guint * out_list_len);
+G_GNUC_INTERNAL
+gdouble	     *rsvg_css_parse_number_list    (const char *in_str, guint * out_list_len);
+G_GNUC_INTERNAL
+gboolean      rsvg_css_parse_overflow       (const char *str, gboolean * inherit);
+G_GNUC_INTERNAL
+char        **rsvg_css_parse_xml_attribute_string   (const char *attribute_string);
+
+#endif /* RSVG_COMPILATION */
 
 G_END_DECLS
 
diff --git a/rsvg-defs.c b/rsvg-defs.c
index 581917e..d2c6a06 100644
--- a/rsvg-defs.c
+++ b/rsvg-defs.c
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /* 
    rsvg-defs.c: Manage SVG defs and references.
  
@@ -26,7 +27,7 @@
 #include "rsvg-private.h"
 #include "rsvg-defs.h"
 #include "rsvg-styles.h"
-#include "rsvg-image.h"
+#include "rsvg-io.h"
 
 #include <glib.h>
 
@@ -34,19 +35,11 @@ struct _RsvgDefs {
     GHashTable *hash;
     GPtrArray *unnamed;
     GHashTable *externs;
-    gchar *base_uri;
-    GSList *toresolve;
-};
-
-typedef struct _RsvgResolutionPending RsvgResolutionPending;
-
-struct _RsvgResolutionPending {
-    RsvgNode **tochange;
-    char *name;
+    RsvgHandle *ctx;
 };
 
 RsvgDefs *
-rsvg_defs_new (void)
+rsvg_defs_new (RsvgHandle *handle)
 {
     RsvgDefs *result = g_new (RsvgDefs, 1);
 
@@ -54,42 +47,38 @@ rsvg_defs_new (void)
     result->externs =
         g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_object_unref);
     result->unnamed = g_ptr_array_new ();
-    result->base_uri = NULL;
-    result->toresolve = NULL;
+    result->ctx = handle; /* no need to take a ref here */
 
     return result;
 }
 
-void
-rsvg_defs_set_base_uri (RsvgDefs * self, gchar * base_uri)
-{
-    self->base_uri = base_uri;
-}
-
 static int
 rsvg_defs_load_extern (const RsvgDefs * defs, const char *name)
 {
     RsvgHandle *handle;
     gchar *filename, *base_uri;
-    GByteArray *chars;
+    char *data;
+    gsize data_len;
+    gboolean rv;
 
-    filename = rsvg_get_file_path (name, defs->base_uri);
+    filename = _rsvg_io_get_file_path (name, rsvg_handle_get_base_uri (defs->ctx));
 
-    chars = _rsvg_acquire_xlink_href_resource (name, defs->base_uri, NULL);
+    data = _rsvg_handle_acquire_data (defs->ctx, name, NULL, &data_len, NULL);
 
-    if (chars) {
+    if (data) {
         handle = rsvg_handle_new ();
 
         base_uri = rsvg_get_base_uri_from_filename (filename);
         rsvg_handle_set_base_uri (handle, base_uri);
         g_free (base_uri);
 
-        if (rsvg_handle_write (handle, chars->data, chars->len, NULL) &&
-            rsvg_handle_close (handle, NULL)) {
+        rv = rsvg_handle_write (handle, (guchar *) data, data_len, NULL);
+        rv = rsvg_handle_close (handle, NULL) && rv;
+        if (rv) {
             g_hash_table_insert (defs->externs, g_strdup (name), handle);
         }
 
-        g_byte_array_free (chars, TRUE);
+        g_free (data);
     }
 
     g_free (filename);
@@ -108,7 +97,7 @@ rsvg_defs_extern_lookup (const RsvgDefs * defs, const char *filename, const char
     }
 
     if (file != NULL)
-        return (RsvgNode *) g_hash_table_lookup (file->priv->defs->hash, name);
+        return g_hash_table_lookup (file->priv->defs->hash, name);
     else
         return NULL;
 }
@@ -122,7 +111,7 @@ rsvg_defs_lookup (const RsvgDefs * defs, const char *name)
         return NULL;
     }
     if (hashpos == name) {
-        return (RsvgNode *) g_hash_table_lookup (defs->hash, name + 1);
+        return g_hash_table_lookup (defs->hash, name + 1);
     } else {
         gchar **splitbits;
         RsvgNode *toreturn;
@@ -146,6 +135,9 @@ rsvg_defs_set (RsvgDefs * defs, const char *name, RsvgNode * val)
 void
 rsvg_defs_register_name (RsvgDefs * defs, const char *name, RsvgNode * val)
 {
+    if (g_hash_table_lookup (defs->hash, name))
+        return;
+
     g_hash_table_insert (defs->hash, g_strdup (name), val);
 }
 
@@ -172,26 +164,3 @@ rsvg_defs_free (RsvgDefs * defs)
     g_free (defs);
 }
 
-void
-rsvg_defs_add_resolver (RsvgDefs * defs, RsvgNode ** tochange, const gchar * name)
-{
-    RsvgResolutionPending *data;
-    data = g_new (RsvgResolutionPending, 1);
-    data->tochange = tochange;
-    data->name = g_strdup (name);
-    defs->toresolve = g_slist_prepend (defs->toresolve, data);
-}
-
-void
-rsvg_defs_resolve_all (RsvgDefs * defs)
-{
-    while (defs->toresolve) {
-        RsvgResolutionPending *data;
-        data = defs->toresolve->data;
-        *(data->tochange) = rsvg_defs_lookup (defs, data->name);
-        g_free (data->name);
-        g_free (data);
-        defs->toresolve = g_slist_delete_link (defs->toresolve, defs->toresolve);
-
-    }
-}
diff --git a/rsvg-defs.h b/rsvg-defs.h
index cb9b53e..3d6802f 100644
--- a/rsvg-defs.h
+++ b/rsvg-defs.h
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-defs.h : SVG defs utilities
 
@@ -30,17 +31,22 @@
 
 #include <glib.h>
 
+#include "rsvg.h"
+
 G_BEGIN_DECLS 
 
-RsvgDefs    *rsvg_defs_new		(void);
+G_GNUC_INTERNAL
+RsvgDefs    *rsvg_defs_new		(RsvgHandle *handle);
+/* for some reason this one's public... */
 RsvgNode    *rsvg_defs_lookup		(const RsvgDefs * defs, const char *name);
+G_GNUC_INTERNAL
 void	     rsvg_defs_set		(RsvgDefs * defs, const char *name, RsvgNode * val);
+G_GNUC_INTERNAL
 void	     rsvg_defs_free		(RsvgDefs * defs);
-void	     rsvg_defs_set_base_uri	(RsvgDefs * self, gchar * base_uri);
-void	     rsvg_defs_add_resolver	(RsvgDefs * defs, RsvgNode ** tochange, const gchar * name);
-void	     rsvg_defs_resolve_all	(RsvgDefs * defs);
+G_GNUC_INTERNAL
 void	     rsvg_defs_register_name	(RsvgDefs * defs, const char *name, RsvgNode * val);
-void	     rsvg_defs_register_memory	(RsvgDefs * defs, RsvgNode * val);
+G_GNUC_INTERNAL
+void	     rsvg_defs_register_memory  (RsvgDefs * defs, RsvgNode * val);
 
 G_END_DECLS
 #endif
diff --git a/rsvg-file-util.c b/rsvg-file-util.c
index 3adde39..e5f058d 100644
--- a/rsvg-file-util.c
+++ b/rsvg-file-util.c
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-file-util.c: SAX-based renderer for SVG files into a GdkPixbuf.
 
@@ -23,99 +24,32 @@
    Author: Raph Levien <raph@artofcode.com>
 */
 
+/**
+ * SECTION: rsvg-pixbuf
+ * @short_description: How to render SVGs into GdkPixbufs, for easy use in GTK+
+ *  applications
+ *
+ * GdkPixbuf is a library for image loading and manipulation. It is part of the
+ * cross-platform GTK+ widget toolkit.
+ */
+
 #include "config.h"
 #include "rsvg.h"
 #include "rsvg-private.h"
+#include "rsvg-io.h"
+#include "rsvg-size-callback.h"
 
 #include <errno.h>
 #include <stdio.h>
 #include <stdlib.h>
-#include <math.h>
 
 #define SVG_BUFFER_SIZE (1024 * 8)
 
-void
-_rsvg_size_callback (int *width, int *height, gpointer data)
-{
-    struct RsvgSizeCallbackData *real_data = (struct RsvgSizeCallbackData *) data;
-    double zoomx, zoomy, zoom;
-
-    int in_width, in_height;
-
-    in_width = *width;
-    in_height = *height;
-
-    switch (real_data->type) {
-    case RSVG_SIZE_ZOOM:
-        if (*width < 0 || *height < 0)
-            return;
-
-        *width = floor (real_data->x_zoom * *width + 0.5);
-        *height = floor (real_data->y_zoom * *height + 0.5);
-        break;
-
-    case RSVG_SIZE_ZOOM_MAX:
-        if (*width < 0 || *height < 0)
-            return;
-
-        *width = floor (real_data->x_zoom * *width + 0.5);
-        *height = floor (real_data->y_zoom * *height + 0.5);
-
-        if (*width > real_data->width || *height > real_data->height) {
-            zoomx = (double) real_data->width / *width;
-            zoomy = (double) real_data->height / *height;
-            zoom = MIN (zoomx, zoomy);
-
-            *width = floor (zoom * *width + 0.5);
-            *height = floor (zoom * *height + 0.5);
-        }
-        break;
-
-    case RSVG_SIZE_WH_MAX:
-        if (*width < 0 || *height < 0)
-            return;
-
-        zoomx = (double) real_data->width / *width;
-        zoomy = (double) real_data->height / *height;
-        if (zoomx < 0)
-            zoom = zoomy;
-        else if (zoomy < 0)
-            zoom = zoomx;
-        else
-            zoom = MIN (zoomx, zoomy);
-
-        *width = floor (zoom * *width + 0.5);
-        *height = floor (zoom * *height + 0.5);
-        break;
-
-    case RSVG_SIZE_WH:
-
-        if (real_data->width != -1)
-            *width = real_data->width;
-        if (real_data->height != -1)
-            *height = real_data->height;
-        break;
-
-    default:
-        g_assert_not_reached ();
-    }
-
-    if (real_data->keep_aspect_ratio) {
-        int out_min = MIN (*width, *height);
-
-        if (out_min == *width) {
-            *height = in_height * ((double) *width / (double) in_width);
-        } else {
-            *width = in_width * ((double) *height / (double) in_height);
-        }
-    }
-}
-
 /* private */
 GdkPixbuf *
 rsvg_pixbuf_from_data_with_size_data (const guchar * buff,
                                       size_t len,
-                                      struct RsvgSizeCallbackData *data,
+                                      /* RsvgSizeCallbackData */ gpointer data,
                                       const char *base_uri, GError ** error)
 {
     RsvgHandle *handle;
@@ -132,25 +66,28 @@ rsvg_pixbuf_from_data_with_size_data (const guchar * buff,
     rsvg_handle_set_base_uri (handle, base_uri);
 
     if (!rsvg_handle_write (handle, buff, len, error)) {
-        g_object_unref (G_OBJECT (handle));
+        (void) rsvg_handle_close (handle, NULL);
+        g_object_unref (handle);
         return NULL;
     }
 
     if (!rsvg_handle_close (handle, error)) {
-        g_object_unref (G_OBJECT (handle));
+        g_object_unref (handle);
         return NULL;
     }
 
     retval = rsvg_handle_get_pixbuf (handle);
-    g_object_unref (G_OBJECT (handle));
+    g_object_unref (handle);
 
     return retval;
 }
 
 static GdkPixbuf *
-rsvg_pixbuf_from_stdio_file_with_size_data (GByteArray * f,
-                                            struct RsvgSizeCallbackData *data,
-                                            gchar * base_uri, GError ** error)
+rsvg_pixbuf_from_stdio_file_with_size_data (const char *data,
+                                            gsize data_len,
+                                            struct RsvgSizeCallbackData *cb_data,
+                                            gchar * base_uri, 
+                                            GError ** error)
 {
     RsvgHandle *handle;
     GdkPixbuf *retval;
@@ -162,38 +99,42 @@ rsvg_pixbuf_from_stdio_file_with_size_data (GByteArray * f,
         return NULL;
     }
 
-    rsvg_handle_set_size_callback (handle, _rsvg_size_callback, data, NULL);
+    rsvg_handle_set_size_callback (handle, _rsvg_size_callback, cb_data, NULL);
     rsvg_handle_set_base_uri (handle, base_uri);
 
-    if (!rsvg_handle_write (handle, f->data, f->len, error)) {
-        g_object_unref (G_OBJECT (handle));
+    if (!rsvg_handle_write (handle, (guchar *) data, data_len, error)) {
+        (void) rsvg_handle_close (handle, NULL);
+        g_object_unref (handle);
         return NULL;
     }
 
     if (!rsvg_handle_close (handle, error)) {
-        g_object_unref (G_OBJECT (handle));
+        g_object_unref (handle);
         return NULL;
     }
 
     retval = rsvg_handle_get_pixbuf (handle);
-    g_object_unref (G_OBJECT (handle));
+    g_object_unref (handle);
 
     return retval;
 }
 
 static GdkPixbuf *
 rsvg_pixbuf_from_file_with_size_data (const gchar * file_name,
-                                      struct RsvgSizeCallbackData *data, GError ** error)
+                                      struct RsvgSizeCallbackData *cb_data, 
+                                      GError ** error)
 {
     GdkPixbuf *pixbuf;
-    GByteArray *f;
+    char *data;
+    gsize data_len;
     GString *base_uri = g_string_new (file_name);
 
-    f = _rsvg_acquire_xlink_href_resource (file_name, base_uri->str, error);
+    data = _rsvg_io_acquire_data (file_name, base_uri->str, NULL, &data_len, NULL, error);
 
-    if (f) {
-        pixbuf = rsvg_pixbuf_from_stdio_file_with_size_data (f, data, base_uri->str, error);
-        g_byte_array_free (f, TRUE);
+    if (data) {
+        pixbuf = rsvg_pixbuf_from_stdio_file_with_size_data (data, data_len,
+                                                             cb_data, base_uri->str, error);
+        g_free (data);
     } else {
         pixbuf = NULL;
     }
